#include "Game.h"


Game::Game(sf::RenderWindow* window)
{
	this->window = window;
}


Game::~Game(void)
{

}

void Game::run()
{
	
	bool test = false;
	projection = 2;
	previousProj = 2;
	jumpStep = 0;
	posX = 0;
	view.setCenter(256, 768);
	view.setSize(512, 512);

	currentProj = &projection;

	currentWorld = new World();
	LevelIO *loadLevel = new LevelIO(window, currentProj, currentWorld);

	
	loadLevel->read();

	entities.push_back(new Perso(sf::Vector2i(200, 800), currentProj, window));
	Perso *pers = static_cast<Perso*>(entities[0]);

	while (window->isOpen())
	{
		sf::Vector3i posPerso = pers->getPos();
		if(posPerso.x > WIN_X-1 && posPerso.y < WIN_Y-1)
		{
			view.setCenter(768, 256);
			window->setView(view);
		}
			
		if(posPerso.x > WIN_X-1 && posPerso.y > WIN_Y - 1)
		{
			view.setCenter(768, 768);
			window->setView(view);
		}
			
		if(posPerso.x < WIN_X-1 && posPerso.y > WIN_Y - 1)
		{
			view.setCenter(256, 768);
			window->setView(view);
		}
			
		if(posPerso.x < WIN_X-1 && posPerso.y < WIN_Y - 1)
		{
			view.setCenter(256, 256);
			window->setView(view);
		}

			

			

		if(jumpStep !=0)
		{
			if(jumpStep < 101)
			{
				pers->jump(jumpStep);
				jumpStep++;
			}
			else 
				jumpStep = 0;
		}

		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Space))
		{
			if(jumpStep == 0) //check if a jump is already launch
			{
				if(projection != 0)
				{
					pers->jump(jumpStep);
					jumpStep++;
				}
			}
		}
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Left))
		{
			if(jumpStep == 0)
				pers->move(Left);
		}
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
		{
			if(jumpStep == 0)
				pers->move(Right);
		}
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Up))
		{
			pers->move(Up);
		}
		if (sf::Keyboard::isKeyPressed(sf::Keyboard::Down))
		{
			pers->move(Down);
		}

		sf::Event event;
		while (window->pollEvent(event))
		{
			if (event.type == sf::Event::Closed)
				window->close();

			if(event.type == sf::Event::KeyReleased)
			{
				pers->move(None);
				if(event.key.code == sf::Keyboard::Escape)
					window->close();
			}
			
			if(event.type == sf::Event::KeyPressed)
			{
				switch(event.key.code)
				{
				case sf::Keyboard::X:
					switch(*currentProj)
					{
					case 1:
						pers->setPos(sf::Vector3i(posPerso.x, SIZE - posPerso.z - 22, posPerso.z));
						pers->setPos(sf::Vector3i(SIZE - posPerso.x, posPerso.y, posPerso.z));
						break;
					case 2:
						pers->setOldPos(sf::Vector3i(posPerso.x, posPerso.y, posPerso.z));
						pers->setPos(sf::Vector3i(posPerso.x, SIZE - posPerso.z - 22, posPerso.z));
						break;
					}
					*currentProj = 0;
					break;
				case sf::Keyboard::Y:
					switch(*currentProj)
					{
					case 0:
						posX = SIZE - posPerso.x;
						pers->setPos(sf::Vector3i(SIZE - posPerso.x, SIZE - posPerso.z - 22, posPerso.z));
						pers->setPos(sf::Vector3i(SIZE - posPerso.x, posPerso.y, posPerso.z));
						break;
					case 2:
						pers->setOldPos(sf::Vector3i(posPerso.x, posPerso.y, posPerso.z));
						pers->setPos(sf::Vector3i(SIZE - posPerso.y, SIZE - posPerso.z - 22, posPerso.z));
						break;
					}
					*currentProj = 1;
					break;
				case sf::Keyboard::Z:
					switch(*currentProj)
					{
					case 0:
						posX = posPerso.x;
						pers->setPos(sf::Vector3i(posPerso.x, pers->getOldPos().y, posPerso.z));
						break;
					case 1:
						pers->setPos(sf::Vector3i(pers->getOldPos().x, SIZE - posPerso.x, posPerso.z));
						break;
					}
					*currentProj = 2;
					break;
				}
			}

		}
		window->clear();

		int filter = 0;

		if(projection == 0)
			filter = 1;
		else if(projection == 1)
			filter = 1;
		else
			filter = 1;

		
		for(int z = 0; z < 32; z++)
		{
			for(int y = 0; y < 32; y++)
			{
				for(int x = 0; x < 32; x++)
				{
					currentWorld->getFirst(z, y, x).render(filter);
				}
			}
		}

		pers->render(0);

		window->display();
	}
}
