#include "LevelIO.h"


LevelIO::LevelIO(sf::RenderWindow *window, int* proj, World* world)
{
	this->window = window;
	this->world = world;
	this->proj = proj;

	texO.loadFromFile("img/layer-ground.png");
	tex = &texO;
}


LevelIO::~LevelIO(void)
{
}

/*Read the world level per level and read level */
void LevelIO::read()
{
	int positionZ = 0;
	int positionY = 0;

	FILE* fichier = NULL;
	char chaine[1003] = "";
	int i = 0;

	fichier = fopen("world/W0.txt", "r");

	if (fichier != NULL)
	{
		while (fgets(chaine, 1003, fichier) != NULL)
		{
			if(chaine[0] == '/')
			{
				positionZ++;
				positionY = positionY - 32; // for the next layer we must restart position Y
			}
			else
			{
				//if(positionY == 0 && positionZ == 0)
					//cout << chaine;
					processLineLevel(chaine, positionY, positionZ);
				
				positionY++;
			}
		}
		fclose(fichier);
	}
}

void LevelIO::write()
{

}

/*Process each line of the level*/
void LevelIO::processLineLevel(char line[],int y, int z)
{
	char* unit;
	int positionX = 0;

	unit = strtok(line, " ");

	while(unit != NULL)
	{
		analyseCodeLayer0(unit[0], sf::Vector3i(positionX, y, z));
		unit = strtok(NULL, " ");
		positionX++;
	}
}

/*Process the unit of the level*/
void LevelIO::processUnitLevel(char unit[], sf::Vector3i pos)
{
	analyseCodeLayer0(unit[0], pos);

	char layer1 [2] = {unit[1], unit[2]};
	analyseCodeLayer1(string(layer1), pos);

	char layer2 [2] = {unit[3], unit[4]};
	analyseCodeLayer2(string(layer2), pos);
}

void LevelIO::analyseCodeLayer0(char ch, sf::Vector3i pos)
{

	switch(ch){
	case '0':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(0, 0, 32, 32), sf::IntRect(0, 0, 32, 32), sf::IntRect(0, 0, 32, 32), ch));
		break;
	case '1':
		world->setFirst(LevelUnit(pos, true, window, proj, tex, sf::IntRect(0, 0, 32, 32), sf::IntRect(0, 0, 32, 32), sf::IntRect(0, 0, 32, 32), ch));
		break;
	case '2':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(32, 0, 32, 32), sf::IntRect(128,0,32, 32), sf::IntRect(32, 0, 32, 32), ch));
		break;
	case '3':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(64,0,32, 32), sf::IntRect(64,0,32, 32), sf::IntRect(128,0,32, 32), ch));
		break;
	case '4':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(96,0,32, 32), sf::IntRect(0, 0, 32, 32), sf::IntRect(64,0,32, 32), ch));
		break;
	case '5':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(128,0,32, 32), sf::IntRect(128,0,32, 32),sf::IntRect(128,32,32, 32), ch));
		break;
	case '6':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(0,32,32, 32), sf::IntRect(128,0,32, 32), sf::IntRect(128,0,32, 32), ch));
		break;
	case '7':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(32,32,32, 32), sf::IntRect(64,0,32, 32), sf::IntRect(128,0,32, 32), ch));
		break;
	case '8':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(64,32,32, 32), sf::IntRect(64,0,32, 32), sf::IntRect(0, 0, 32, 32), ch));
		break;
	case '9':
		world->setFirst(LevelUnit(pos, false, window, proj, tex, sf::IntRect(96,32,32, 32), sf::IntRect(128,0,32, 32), sf::IntRect(0, 0, 32, 32), ch));
		break;
	}
}

void LevelIO::analyseCodeLayer1(string ch, sf::Vector3i pos)
{
	if(ch == "00")
	{

	}
	else if(ch == "01")
	{

	}
	else if(ch == "02")
	{

	}
	else if(ch == "03")
	{

	}
	else if(ch == "04")
	{

	}
	else if(ch == "05")
	{

	}
	else if(ch == "06")
	{

	}
	else if(ch == "07")
	{

	}
	else if(ch == "08")
	{

	}
	else{

	}
}

void LevelIO::analyseCodeLayer2(string ch, sf::Vector3i pos)
{
	if(ch == "00")
	{

	}
	else if(ch == "01")
	{

	}
	else if(ch == "02")
	{

	}
	else if(ch == "03")
	{

	}
	else if(ch == "04")
	{

	}
	else if(ch == "05")
	{

	}
	else if(ch == "06")
	{

	}
	else if(ch == "07")
	{

	}
	else if(ch == "08")
	{

	}
	else{

	}
}





