#include "Perso.h"

Perso::Perso(sf::Vector2i pos, int *proj, sf::RenderWindow *window) : Entity(sf::Vector3i(pos.x,pos.y,0), window, proj)
{
	repeat = 0;
	currentMov = Right;
	statWalk = 0;
	jumpAction = false;

	oldPos.x = pos.x;
	oldPos.y= pos.y;
	oldPos.z = 0;
	
	tex.loadFromFile("img/perso.png");
	int i = 0;
	
	while(i < 4)
	{
		spr[i].setTexture(tex);
		spr[i].setTextureRect(sf::Rect<int>(10*i, 0, 10, 20));
		i++;
	}

	for(int j = 0; j < 10; j++)
	{
		spr[i].setTexture(tex);
		spr[i].setTextureRect(sf::Rect<int>(10*j, 20, 10, 18));
		i++;
	}

	current = spr[5];
	current.setPosition(pos.x,pos.y);
}

Perso::~Perso(void)
{
}

sf::Vector3i Perso::getOldPos()
{
	return oldPos;
}

void Perso::setOldPos(sf::Vector3i oldPos)
{
	this->oldPos = oldPos;
}

bool Perso::checkBorder(Movement mov)
{
	sf::Vector2f currentPos = current.getPosition();

	switch(mov){
	case Up:
		if(currentPos.y < 3)
			return false;
		break;
	case Down:
		if (currentPos.y > WIN_Y*2)
			return false;
		break;
	case Left:
		if(currentPos.x < 3)
			return false;
		break;
	case Right:
		if(currentPos.x > WIN_X*2)
			return false;
		break;
	}
	return true;
}

void Perso::move(Movement mov)
{
	if(*proj == 2 && checkBorder(mov))
	{
	switch(mov){
	case Up:
		pos.y--;
		if(statWalk == 0 && PrevMov == None)
			current = spr[4];
		else
			current = spr[statWalk];

		if(repeat == 6){
			repeat = 0;
			if(statWalk == 1)
				statWalk--;
			else
				statWalk++;
		}
		repeat++;		
		PrevMov = Up;
		break;
	case Down:
		pos.y++;

		if(statWalk == 0 && PrevMov == None)
			current = spr[5];
		else
			current = spr[statWalk+2];

		if(repeat == 6)
		{
			repeat = 0;
			if(statWalk == 1)
				statWalk--;
			else
				statWalk++;
		}
		repeat++;
		PrevMov = Down;
		break;
	case Left:
		if(PrevMov != Left)
		{
			statWalk = 0;
		}
		pos.x--;
		current = spr[statWalk+9];

		if(repeat == 5)
		{
			repeat = 0;
			if(statWalk == 2)
				statWalk = 0;
			else
				statWalk++;
		}
		
		repeat++;
		PrevMov = Left;
		break;
	case Right:
		if(PrevMov != Right)
		{
			statWalk = 0;
		}
		pos.x++;
		current = spr[statWalk+6];

		if(repeat == 5)
		{
			repeat = 0;
			if(statWalk == 2)
				statWalk = 0;
			else
				statWalk++;	
		}
		repeat++;
		PrevMov = Right;
		break;
	case None:
		statWalk = 0;
		repeat = 0;
		PrevMov = None;
		break;
	}

	current.setPosition(pos.x, pos.y); // Update the sprite position
	}
	else if(checkBorder(mov))
	{
		switch (mov){
		case Left:
			currentMov = Left;
			pos.x--;

			if(jumpAction)
			{
				statWalk = 0;
				repeat = 0;
			}
			else
			{
				if(PrevMov != Left)
				{
					statWalk = 0;
				}
				current = spr[statWalk+9];

				if(repeat == 5)
				{
					repeat = 0;
					if(statWalk == 2)
						statWalk = 0;
					else
						statWalk++;
				}

				repeat++;
				PrevMov = Left;
			}
			
			break;
		case Right:
			currentMov = Right;
			pos.x++;

			if(jumpAction)
			{
				statWalk = 0;
				repeat = 0; 
			}
			else{
				if(PrevMov != Right)
				{
					statWalk = 0;
				}
				current = spr[statWalk+6];

				if(repeat == 5)
				{
					repeat = 0;
					if(statWalk == 2)
						statWalk = 0;
					else
						statWalk++;	
				}
				repeat++;
				PrevMov = Right;
			}
		}
		current.setPosition(pos.x, pos.y);
	}
}

void Perso::jump(int jumpStep)
{
	jumpAction = true;

		if(currentMov == Left)
			current = spr[12];
		else
			current = spr[13];

	if(sf::Keyboard::isKeyPressed(sf::Keyboard::Left))
		pos.x--;
	if(sf::Keyboard::isKeyPressed(sf::Keyboard::Right))
		pos.x++;

	if(jumpStep < 50)
		pos.y--;
	else
		pos.y++;

	if(jumpStep = 1000){
		jumpAction = false;
	}
		
		
	current.setPosition(pos.x, pos.y);
}

void Perso::moveJump(Movement mov)
{
	switch (mov)
	{
	case Left:
		pos.x--;
		break;
	case Right:
		pos.x++;
		break;
	}
	current.setPosition(pos.x, pos.y);
}

void Perso::render(int filter)
{
	window->draw(current);
}
